#include <stdio.h>

int x[104], y[104], n;
int cache[300][300];

bool isin(int px, int py) {
	static int i, Ax, Ay, Bx, By, cnt;
	static double s, t;
	static bool roh;
	if (cache[px+150][py+150] != -1) return cache[px+150][py+150];
	roh = false;
	cnt = 0;
	for (i = 0; i < n; i++) {
		Ax = x[i]; Ay = y[i]; Bx = x[i+1]; By = y[i+1];
		if (px == x[i] && py == y[i]) {roh = true; break;}
		if (By == Ay) {
			if ((px >= Ax && px <= Bx) || (px >= Bx && px <= Ax)) {printf("-%d\n", i); cnt++;}
		} else {
			s = (py - Ay) / ((double)By - Ay);
			t = Ax + s*(Bx-Ax) - px;
			if (s > 1e-9 && s < 1 + 1e-9 && t > -1e-9) {printf("-%d %lf %lf\n", i, s, t); cnt++;}
		}
	}
	printf("%d %d %d %d\n", px, py, cnt, cnt > 0 && (cnt & 1));
	return (cache[px+150][py+150] = (roh || (cnt > 0 && (cnt & 1))));
}

int main() {
	int i, minx, maxx, miny, maxy, j, cnt;
	while (scanf("%d", &n), n > 0) {
		for (i = 0; i < n; i++) {
			scanf("%d%d", &x[i], &y[i]);
			if (minx > x[i]) minx = x[i];
			if (maxx < x[i]) maxx = x[i];
			if (miny > y[i]) miny = y[i];
			if (maxy < y[i]) maxy = y[i];
		}
		x[n] = x[0]; y[n] = y[0];
		for (i = minx-1; i <= maxx+1; i++) {
			for (j = miny-1; j <= maxy+1; j++) {
				cache[i+150][j+150] = -1;
			}
		}
		cnt = 0;
		for (i = minx; i <= maxx; i++) {
			for (j = miny; j <= maxy; j++) {
				if (isin(i, j) && isin(i+1, j) && isin(i, j+1) && isin(i+1, j+1)) cnt++; 
			}
		}
		printf("%d\n", cnt);
	}
	return 0;
}
